using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.IO;
using System.Text.RegularExpressions;
using System.Threading;
using System.Globalization;

namespace MMServer
{

    public partial class Form1 : Form
    {
        public simulator sim;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            sim = new simulator(this);
        }

        public bool autorun()
        {
            return checkBox1.Checked;
        }

        public void setkorak(int n, string state)
        {
            label1.Text = "K=" + n.ToString() + "; S=" + state;
        }

        public void setmacka(string str)
        {
            label2.Text = "Macka:\n" + str;
        }

        public void setmis(string str)
        {
            label3.Text = "Mis:\n" + str;
        }

        public void shrani_set(bool b)
        {
            button5.Enabled = b;
        }

        public void update_display()
        {
            pictureBox1.Invalidate();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            sim.step(true);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            sim.step(false);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            sim.stop();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            if (sim.reset()) set_scroller(0);
        }

        private void button5_Click(object sender, EventArgs e)
        {
            if (sim.state != simulator.sim_state.sstGameOver) return;
            saveFileDialog1.ShowDialog();
        }

        private void saveFileDialog1_FileOk(object sender, CancelEventArgs e)
        {
            if (sim.state != simulator.sim_state.sstGameOver) return;
            if (sim != null) sim.zgodovina.save(saveFileDialog1.FileName, sim.zoo[0].tip == zival.pasma.pMis);
        }

        private void hScrollBar1_ValueChanged(object sender, EventArgs e)
        {
            pictureBox1.Invalidate();
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            pictureBox1.Invalidate();
        }

        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if ((textBox1.Text.Length >= 4) && (e.KeyChar != '\b')) e.Handled = true;
            if (!(((e.KeyChar >= '0') && (e.KeyChar <= '9')) || (e.KeyChar == '\b'))) e.Handled = true;
        }

        public void set_scroller(int len)
        {
            if (len != hScrollBar1.Value)
            {
                hScrollBar1.Maximum = len;
                hScrollBar1.Value = len;
            }
            else
            {
                pictureBox1.Invalidate();
            }
        }

        private void pictureBox1_Paint(object sender, PaintEventArgs e)
        {
            int TraceLen;
            try
            {
                TraceLen = Int32.Parse(textBox1.Text);
            }
            catch (Exception f)
            {
                TraceLen = 0;
            }
            if ((TraceLen < 1) || (TraceLen > 3001)) TraceLen = 3;
            int TraceEnd = hScrollBar1.Value;

            Point[] muca, mis;
            Stanje mucas, miss;
            sim.zgodovina.getTrace(TraceLen, TraceEnd, pictureBox1.Width, pictureBox1.Height, 0, 0, out muca, out mis);
            sim.zgodovina.GetStanje(TraceEnd, out mucas, out miss);
            Pen rpen = new Pen(Color.Red, 1.0f);
            Pen bpen = new Pen(Color.Blue, 1.0f);
            if ((muca != null) && (mis != null))
            {
                if (muca.Length == 0)
                {
                } else {
                    if (muca.Length > 1)
                    {
                        e.Graphics.DrawLines(rpen, muca);
                        e.Graphics.DrawLines(bpen, mis);
                    }
                    Brush r = new SolidBrush(Color.Red);
                    Brush b = new SolidBrush(Color.Blue);
                    int hw = (int)(pictureBox1.Width * simulator.doseg_lovca);
                    int hh = (int)(pictureBox1.Height * simulator.doseg_lovca);
                    e.Graphics.FillEllipse(r, muca[muca.Length - 1].X - 2, muca[muca.Length - 1].Y - 2, 4, 4);
                    e.Graphics.DrawEllipse(rpen, muca[muca.Length - 1].X - hw, muca[muca.Length - 1].Y - hh, (float)(2.0*hw), (float)(2.0*hh));
                    e.Graphics.FillEllipse(b, mis[mis.Length - 1].X - 2, mis[mis.Length - 1].Y - 2, 4, 4);
                }
            }
            if ((mucas != null) && (miss != null))
            {
                label4.Text =
                    "Macka:"
                + "\nX: " + mucas.x.ToString()
                + "\nY: " + mucas.y.ToString()
                + "\nD: " + degs(mucas.d).ToString()
                + "\nV: " + mucas.v.ToString()
                + "\ndD: " + degs(mucas.dd).ToString()
                + "\ndV: " + mucas.dv.ToString()
                + "\n\nMis:"
                + "\nX: " + miss.x.ToString()
                + "\nY: " + miss.y.ToString()
                + "\nD: " + degs(miss.d).ToString()
                + "\nV: " + miss.v.ToString()
                + "\ndD: " + degs(miss.dd).ToString()
                + "\ndV: " + miss.dv.ToString();
            }
            else
            {
            }
        }

        private double degs(double x)
        {
            if (checkBox2.Checked) return 180.0 * (x / Math.PI);
            else return x;
        }

        private void pictureBox1_SizeChanged(object sender, EventArgs e)
        {
            pictureBox1.Invalidate();
        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            pictureBox1.Invalidate();
        }
    }

    public class Stanje {
        public double x, y, d, v;
        public double dd, dv;

        public void update(zival z)
        {
            x = z.x;
            y = z.y;
            d = z.d;
            v = z.v;
            dd = z.dd;
            dv = z.dv;
        }
        public Stanje()
        {
            x = y = d = v = dd = dv = -1.0;
        }
        public Stanje(zival z)
        {
            update(z);
        }
    }

    public class MMStanje {
        public Stanje[] zivali;

        public MMStanje() {
            zivali = new Stanje[2];
            zivali[0] = new Stanje();
            zivali[1] = new Stanje();
        }

        public MMStanje(zival z0, zival z1)
        {
            zivali = new Stanje[2];
            zivali[0] = new Stanje(z0);
            zivali[1] = new Stanje(z1);
        }

        public void update(zival z0, zival z1)
        {
            zivali[0].update(z0);
            zivali[1].update(z1);
        }

        public void save_one(StreamWriter w, Stanje z)
        {
            w.Write(String.Format(CultureInfo.InvariantCulture, "{0}\t{1}\t{2}\t{3}\t{4}\t{5}", z.x, z.y, z.d, z.v, z.dd, z.dv));
        }

        public void save(StreamWriter w, bool swap)
        {
            Stanje z0, z1;
            if (!swap)
            {
                z0 = zivali[0];
                z1 = zivali[1];
            }
            else
            {
                z0 = zivali[1];
                z1 = zivali[0];
            }
            save_one(w, z0);
            w.Write("\t");
            save_one(w, z1);
            w.WriteLine();
        }
    }

    public class log {
        public MMStanje[] zapis;
        public int korak;
        public bool[] zmaga;
        public bool GameOver;
        public int muidx, miidx;

        public log()
        {
            korak = -1;
            muidx = miidx = -1;
            zmaga = new bool[2];
            GameOver = false;
            zapis = new MMStanje[3010];
        }

        public void update(zival z0, zival z1)
        {
            if (korak == -1)
            {
                muidx = (z0.tip == zival.pasma.pMucka) ? 0 : 1;
                miidx = (z0.tip == zival.pasma.pMucka) ? 1 : 0;
            }
            ++korak;
            zapis[korak] = new MMStanje(z0, z1);
        }

        public void gameover(bool k0, bool k1)
        {
            zmaga[0] = k0;
            zmaga[1] = k1;
            GameOver = true;
        }

        public void save(string FNm, bool swap)
        {
            if (!GameOver) return;
            StreamWriter f = new StreamWriter(FNm);

            f.WriteLine("Korakov = " + (korak+1).ToString());
            f.WriteLine("X\tY\tD\tV\tdD\tdV\tX\tY\tD\tV\tdD\tdV");
            for (int i = 0; i <= korak; i++)
            {
                zapis[i].save(f, swap);
            }
            if (!swap)
            {
                f.WriteLine(zmaga[0].ToString() + " " + zmaga[1].ToString());
            }
            else
            {
                f.WriteLine(zmaga[1].ToString() + " " + zmaga[0].ToString());
            }
            f.Flush();
            f.Close();
        }

        public void getTrace(int len, int endidx, int w, int h, int l, int t, out Point[] muca, out Point[] mis)
        {
            if (endidx > korak) endidx = korak;
            int begidx = endidx - (len - 1);
            if (begidx < 0) begidx = 0;
            int reallen = endidx - begidx + 1;
            if ((korak == -1) || (len == 0))
            {
                muca = new Point[0];
                mis = new Point[0];
            }
            else
            {
                muca = new Point[reallen];
                mis = new Point[reallen];

                for (int i = begidx; i <= endidx; i++)
                {
                    muca[i - begidx].X = l + (int)(zapis[i].zivali[muidx].x * (w - 1));
                    muca[i - begidx].Y = t + (h - 1) - (int)(zapis[i].zivali[muidx].y * (h - 1));

                    mis[i - begidx].X = l + (int)(zapis[i].zivali[miidx].x * (w - 1));
                    mis[i - begidx].Y = t + (h - 1) - (int)(zapis[i].zivali[miidx].y * (h - 1));
                }
            }
        }

        public void GetStanje(int idx, out Stanje mu, out Stanje mi)
        {
            if (idx > korak) idx = korak;
            if (korak == -1)
            {
                mu = null;
                mi = null;
            }
            else
            {
                mu = zapis[idx].zivali[muidx];
                mi = zapis[idx].zivali[miidx];
            }
        }
    }

    public class simulator
    {
        public enum sim_state { sstWaitReg, sstReady, sstIdle, sstWaitWake, sstWaitStep, sstGameOver, sstTmpUpdate };
        public enum razlog { kZaletena, kUjeta, kPrekoracitev };

        public const double max_dd = 5 * Math.PI / 180.0;
        public const double max_dv = 0.001;
        public const double doseg_lovca = 0.01;
        public const int max_korakov = 3000;

        public delegate void AsyncOnPrijavljena(zival z);
        public delegate void AsyncOnDisconnect(zival z);
        public delegate void AsyncOnZnanaIdentiteta(zival z);
        public delegate void AsyncOnPripravljena(zival z, double d);
        public delegate void AsyncOnIzracunKoncan(zival z, double dd, double dv);

        public AsyncOnPrijavljena AOnPrijavljena;
        public AsyncOnDisconnect AOnDisconnect;
        public AsyncOnZnanaIdentiteta AOnZnanaIdentiteta;
        public AsyncOnPripravljena AOnPripravljena;
        public AsyncOnIzracunKoncan AOnIzracunKoncan;

        public Form1 parent;
        public sim_state state;
        TcpListener tcpListener;
        public zival[] zoo;
        public log zgodovina;
        public bool autostep;

        public simulator(Form1 pr)
        {
            parent = pr;
            zoo = new zival[2];
            zgodovina = new log();
            autostep = false;
            tcpListener = new TcpListener(IPAddress.Parse("0.0.0.0"), 1174);
            tcpListener.Start();

            AOnPrijavljena = new AsyncOnPrijavljena(this.OnPrijavljena);
            AOnDisconnect = new AsyncOnDisconnect(this.OnDisconnect);
            AOnZnanaIdentiteta = new AsyncOnZnanaIdentiteta(this.OnZnanaIdentiteta);
            AOnPripravljena = new AsyncOnPripravljena(this.OnPripravljena);
            AOnIzracunKoncan = new AsyncOnIzracunKoncan(this.OnIzracunKoncan);

            tcpListener.BeginAcceptTcpClient(new AsyncCallback(DoAcceptTcpClient), this);
            setstate(sim_state.sstWaitReg);
        }

        public void resetclient(int id)
        {
            if (zoo[id] != null)
            {
                zoo[id].ResetClient();
            }
        }
        public void reset_simulator()
        {
            zgodovina = new log();
            parent.set_scroller(0);
            resetclient(0);
            resetclient(1);
            setstate(sim_state.sstWaitReg);
            if ((zoo[0] != null) && (zoo[1] != null) && (zoo[0].state == zival.zival_state.stPrijavljena) && (zoo[1].state == zival.zival_state.stPrijavljena)) 
                setstate(sim_state.sstReady);
        }
        public bool reset()
        {
            if (state == sim_state.sstReady) return true;
            if ((state != sim_state.sstIdle) && (state != sim_state.sstGameOver)) return false;
            reset_simulator();
            return true;
        }

        public void rand_zival(zival z, Random rnd)
        {
            z.y = 0.1 + 0.8 * rnd.NextDouble();
            z.x = 0.1 + 0.1 * rnd.NextDouble();
            if (z.tip == zival.pasma.pMis) z.x += 0.7;
            z.d = z.v = 0;
        }
        public void zbudi()
        {
            setstate(sim_state.sstWaitWake);

            Random rnd = new Random();
            rand_zival(zoo[0], rnd);
            rand_zival(zoo[1], rnd);
            zoo[0].ZbudiSe(zoo[1]);
            zoo[1].ZbudiSe(zoo[0]);
        }
        public void korak()
        {
            setstate(sim_state.sstWaitStep);

            zoo[0].KamGres(zoo[1]);
            zoo[1].KamGres(zoo[0]);
        }

        public bool step(bool auto)
        {
            if (zgodovina.korak == -1) {
                if (state != sim_state.sstReady) return false;
                autostep = auto;
                zbudi();
            } else {
                if (state != sim_state.sstIdle) return false;
                autostep = auto;
                korak();
            }

            return true;
        }
        public void stop()
        {
            autostep = false;
        }

        public void DoAcceptTcpClient(IAsyncResult r)
        {
            simulator sim = (simulator)r.AsyncState;
            if (sim == null) return;
            TcpListener tcpListener = sim.tcpListener;
            try
            {
                TcpClient client = tcpListener.EndAcceptTcpClient(r);
                zival z = new zival(client, sim);
                sim.parent.Invoke(sim.AOnPrijavljena, z);
            }
            catch (Exception e)
            {
                MessageBox.Show(e.ToString());
            }
            finally
            {
                tcpListener.BeginAcceptTcpClient(new AsyncCallback(sim.DoAcceptTcpClient), sim);
            }
        }

        int idx(zival z)
        {
            if (z == zoo[0]) return 0;
            if (z == zoo[1]) return 1;
            return -1;
        }
        int zidx(zival.pasma p)
        {
            if ((zoo[0] != null) && (zoo[0].tip == p)) return 0;
            if ((zoo[1] != null) && (zoo[1].tip == p)) return 1;
            return -1;
        }

        void end_outstanding_one(int id)
        {
            if ((zoo[id] != null) && ((zoo[id].state == zival.zival_state.stBujenjeKoncano) || 
                (zoo[id].state == zival.zival_state.stCaka) || (zoo[id].state == zival.zival_state.stRazmislekKoncan) || 
                (zoo[id].state == zival.zival_state.stRazmislja) || (zoo[id].state == zival.zival_state.stZbujaSe))) {

                    zoo[id].ResetClient();
            }
        }
        void end_outstanding()
        {
            end_outstanding_one(0);
            end_outstanding_one(1);
        }
        string getstatus(int id)
        {
            if (id == -1) return "-";
            return zoo[id].ime 
                + "\n" + zoo[id].state.ToString()
                + (zgodovina.GameOver ? ("\n" + (zgodovina.zmaga[id]?"zmagala":"zgubila")) : "");
        }
        void gui_status_update(bool update)
        {
            parent.setkorak(zgodovina.korak, state.ToString());
            parent.setmacka(getstatus(zidx(zival.pasma.pMucka)));
            parent.setmis(getstatus(zidx(zival.pasma.pMis)));
            if (update)
            {
                parent.Update();
            }
        }

        void setstate(sim_state st)
        {
            gui_status_update(false);
            if (st == sim_state.sstTmpUpdate) return;

            if (state != st)
            {
                state = st;

                if (st == sim_state.sstWaitReg) end_outstanding();
                if ((st == sim_state.sstReady) && (parent.autorun())) step(true);
                if ((st == sim_state.sstIdle) || (st == sim_state.sstGameOver)) parent.set_scroller((zgodovina.korak == -1) ? 0:zgodovina.korak);
                if ((st == sim_state.sstIdle) && autostep) step(true);

                if (st != sim_state.sstGameOver) parent.shrani_set(false);
                if (st == sim_state.sstGameOver) parent.shrani_set(true);
            }

            gui_status_update(true);
        }

        public void preveri_pripravljenost()
        {
            if ((zoo[0].state == zival.zival_state.stBujenjeKoncano) && (zoo[1].state == zival.zival_state.stBujenjeKoncano))
            {
                zoo[0].state = zoo[1].state = zival.zival_state.stCaka;
                zgodovina.update(zoo[0], zoo[1]);
                setstate(sim_state.sstIdle);
            }
        }

        double limit(double x, double lim)
        {
            if (Math.Abs(x) > lim) return Math.Sign(x) * lim;
            else return x;
        }
        public void update_zival(zival z, double dd, double dv)
        {
            z.dd = limit(dd, max_dd);
            z.dv = limit(dv, max_dv);

            z.d = (z.d + z.dd) % (2.0 * Math.PI);
            z.v += z.dv;
            if (z.v < 0) z.v = 0;

            z.x += z.v * Math.Cos(z.d);
            z.y += z.v * Math.Sin(z.d);
        }
        public double razdalja()
        {
            double dx = zoo[0].x - zoo[1].x;
            double dy = zoo[0].y - zoo[1].y;
            return Math.Sqrt(dx*dx + dy*dy);
        }
        public bool zaletena(zival z)
        {
            return ((z.x < 0.0) || (z.x > 1.0) || (z.y < 0.0) || (z.y > 1.0));
        }

        public bool doloci_konec(zival z, razlog r, bool zaletena)
        {
            if (zaletena) return false;
            if (z.tip == zival.pasma.pMucka)
            {
                if (r == razlog.kZaletena) return true;
                if (r == razlog.kUjeta) return true;
                if (r == razlog.kPrekoracitev) return false;
            }
            else
            {
                if (r == razlog.kZaletena) return true;
                if (r == razlog.kUjeta) return false;
                if (r == razlog.kPrekoracitev) return true;
            }

            return false;
        }
        public void Konec(razlog r, bool zaletena0, bool zaletena1)
        {
            bool k0 = doloci_konec(zoo[0], r, zaletena0);
            bool k1 = doloci_konec(zoo[1], r, zaletena1);

            zoo[0].KonecIgre(k0 ? zival.razlog.rZmagala : zival.razlog.rZgubila);
            zoo[1].KonecIgre(k1 ? zival.razlog.rZmagala : zival.razlog.rZgubila);

            zgodovina.gameover(k0, k1);
            setstate(sim_state.sstGameOver);
        }
        public bool koncan_razmislek()
        {
            return ((zoo[0].state == zival.zival_state.stRazmislekKoncan) && (zoo[1].state == zival.zival_state.stRazmislekKoncan));
        }
        public void preveri_pogoje()
        {
            if (!koncan_razmislek()) return;

            zgodovina.update(zoo[0], zoo[1]);

            if (razdalja() <= doseg_lovca) { Konec(razlog.kUjeta, false, false); return; }

            bool zaletena0 = zaletena(zoo[0]);
            bool zaletena1 = zaletena(zoo[1]);
            if (zaletena0 || zaletena1) { Konec(razlog.kZaletena, zaletena0, zaletena1); return; }

            if (zgodovina.korak > 3000) { 
                Konec(razlog.kPrekoracitev, false, false); return; 
            }

            zoo[0].state = zoo[1].state = zival.zival_state.stCaka;
            setstate(sim_state.sstIdle);
        }

        public void OnPrijavljena(zival z)
        {
            try
            {
                int idx = -1;
                if (zoo[0] == null) idx = 0;
                else if (zoo[1] == null) idx = 1;
                else
                {
                    z.PrijavaNeuspesna("Trenutno sta ze povezani 2 zivali.");
                }
                if (idx != -1) zoo[idx] = z;
            }
            catch (Exception e)
            {
                //MessageBox.Show(e.ToString());
            }
        }

        public void OnDisconnect(zival z)
        {
            try
            {
                int id = idx(z);
                if (id != -1)
                {
                    zoo[idx(z)] = null;
                    reset_simulator();
                }
            }
            catch (Exception e)
            {
                //MessageBox.Show(e.ToString());
            }
        }

        public void OnZnanaIdentiteta(zival z)
        {
            try
            {
                int id = idx(z);
                if (id == -1) return;
                int nid = (id == 0) ? 1 : 0;

                if (((zoo[0] != null) && (zoo[1] != null)) && (zoo[id].tip == zoo[nid].tip))
                {
                    z.PrijavaNeuspesna("Zival taksne pasme ze obstaja");
                }

                z.PrijavaUspesna();

                if ((zoo[0] != null && zoo[1] != null) && (zoo[id].tip != zival.pasma.pNeznana && zoo[nid].tip != zival.pasma.pNeznana))
                {
                    if (zoo[0].state != zival.zival_state.stPrijavljena) throw new Exception("Zival 0 ni pripravljena.");
                    if (zoo[1].state != zival.zival_state.stPrijavljena) throw new Exception("Zival 1 ni pripravljena.");
                    setstate(sim_state.sstReady);
                }
                else
                {
                    setstate(sim_state.sstTmpUpdate);
                }
            }
            catch (Exception e)
            {
                //MessageBox.Show(e.ToString());
            }
        }

        public void OnPripravljena(zival z, double d)
        {
            z.dd = z.d = d % (2.0 * Math.PI);
            z.dv = z.v = 0;
            z.state = zival.zival_state.stBujenjeKoncano;
            preveri_pripravljenost();
        }
        public void OnIzracunKoncan(zival z, double dd, double dv)
        {
            update_zival(z, dd, dv);
            z.state = zival.zival_state.stRazmislekKoncan;
            preveri_pogoje();
        }
    }

    public class zival
    {
        public enum zival_state { stNeznana, stPrijavljena, stZbujaSe, stBujenjeKoncano, stCaka, stRazmislja, stRazmislekKoncan, stKill };
        public enum razlog { rNapaka=0, rZmagala=1, rZgubila=2 };
        public enum pasma { pNeznana = 0, pMucka = 1, pMis = 2 };
        public zival_state state;
        public pasma tip;
        public string ime;

        public double x, y, d, v;
        public double dd, dv;

        public delegate string AsyncReadLine();
        AsyncReadLine rl;

        simulator sim;
        TcpClient cli;
        NetworkStream ns;
        StreamReader sr;
        StreamWriter sw;

        public zival(TcpClient s, simulator psim)
        {
            sim = psim;
            cli = s;
            state = zival_state.stNeznana;
            tip = pasma.pNeznana;
            ime = "XXNeznana";

            try
            {
                ns = cli.GetStream();
                sr = new StreamReader(ns);
                sw = new StreamWriter(ns);
                sw.AutoFlush = true;

                sw.WriteLine("AVE MackaMis Razvojni streznik v 0.1");

                rl = new AsyncReadLine(sr.ReadLine);
                rl.BeginInvoke(new AsyncCallback(OnReadLine), this);
            }
            catch (Exception e)
            {
                //MessageBox.Show(e.ToString());
            }
        }

        bool parseinput(zival z, string s)
        {
            char[] delimiter = new char[] { ' ' };

            string[] split = s.Split(delimiter, 2);

            string cmd = split[0];
            string rest = split[1];

            try
            {
                if (cmd == "AVE")
                {
                    if (z.state != zival_state.stNeznana) return false;

                    string[] ave = rest.Split(delimiter, 2);

                    if (ave[0] == "MACKA") z.tip = pasma.pMucka;
                    else if (ave[0] == "MIS") z.tip = pasma.pMis;
                    else return false;

                    z.ime = ave[1];
                    z.sim.parent.Invoke(z.sim.AOnZnanaIdentiteta, z);
                }
                else if (cmd == "BUDNA")
                {
                    if (z.state != zival_state.stZbujaSe) return false;
                    double d = Double.Parse(rest, CultureInfo.InvariantCulture);
                    z.sim.parent.Invoke(z.sim.AOnPripravljena, z, d);
                }
                else if (cmd == "QVR")
                {
                    if (z.state != zival_state.stRazmislja) return false;
                    string[] q = rest.Split(' ');
                    double dd = Double.Parse(q[0], CultureInfo.InvariantCulture);
                    double dv = Double.Parse(q[1], CultureInfo.InvariantCulture);
                    z.sim.parent.Invoke(z.sim.AOnIzracunKoncan, z, dd, dv);
                }
                else if (cmd == "ADIJO") return false;
            }
            catch (Exception e)
            {
                //MessageBox.Show(e.ToString());
                return false;
            }

            return true;
        }

        public void OnReadLine(IAsyncResult r)
        {
            zival z = (zival)r.AsyncState;
            if (z == null) return;

            try
            {
                string str = z.rl.EndInvoke(r);
                if (str == null) throw new Exception("Client disconnected");
                if (!z.parseinput(z, str)) z.Adijo(z);
                z.rl.BeginInvoke(new AsyncCallback(z.OnReadLine), z);
            }
            catch (Exception e)
            {
                //MessageBox.Show(e.ToString());
                z.Prekini(z);
            }
        }

        public void PrijavaUspesna()
        {
            state = zival_state.stPrijavljena;
            try
            {
                sw.WriteLine("PRIJAVA USPESNA");
            }
            catch (Exception e)
            {
                Prekini(this);
            }
        }
        public void PrijavaNeuspesna(string razlog)
        {
            if (state != zival_state.stNeznana) throw new Exception("PrijavaNeuspesna: nepravilen prehod stanj");
            state = zival_state.stKill;
            try
            {
                sw.WriteLine("PRIJAVA NEUSPESNA " + razlog);
            }
            catch (Exception e)
            {
            }
            Prekini(this);
        }
        public void ZbudiSe(zival op)
        {
            state = zival_state.stZbujaSe;
            try
            {
                sw.WriteLine(String.Format(CultureInfo.InvariantCulture, "ZBUDI_SE {0} {1} {2} {3}", x, y, op.x, op.y));
            }
            catch (Exception e)
            {
                Prekini(this);
            }
        }
        public void KamGres(zival op)
        {
            if (state == zival_state.stCaka)
            {
                state = zival_state.stRazmislja;
                try
                {
                    sw.WriteLine(String.Format(CultureInfo.InvariantCulture, "QV {0} {1} {2} {3} {4} {5} {6} {7}", x, y, d, v, op.x, op.y, op.d, op.v));
                }
                catch (Exception e)
                {
                    Prekini(this);
                }
            }
            else throw new Exception("KamGres: zival je v napacnem stanju: " + state.ToString());
        }
        public void KonecIgre(razlog r)
        {
            state = zival_state.stPrijavljena;
            try
            {
                sw.WriteLine(String.Format("KONEC_IGRE {0:D}", r));
            }
            catch (Exception e)
            {
                Prekini(this);
            }
            x = y = d = v = dd = dv = -1.0;
        }
        public void ResetClient()
        {
            KonecIgre(razlog.rNapaka);
            x = y = d = v = dd = dv = -1.0;
        }

        public void Adijo(zival z)
        {
            z.state = zival_state.stKill;
            try
            {
                z.sw.WriteLine("ADIJO");
            }
            catch (Exception e)
            {
                //MessageBox.Show(e.ToString());
            }

            Prekini(z);
        }
        public void Prekini(zival z)
        {
            try
            {
                z.sim.parent.Invoke(z.sim.AOnDisconnect, z);
                z.ns.Close();
                z.cli.Close();
            }
            catch (Exception e)
            {
                //MessageBox.Show(e.ToString());
            }
        }
    }
}
